//Fortran: EQUIVALENCE ( ... )
Unit SF59R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF35R_p;

procedure SF59R(X :Real; var RM :Real);

implementation

procedure SF59R(X :Real; var RM :Real);
var
K :Integer;
SPI,SUM,SLAG :Real;
const
SYS010 :Real = 0.79788456080286535587989211986876;
AL :Real = 12.0;
SYS029 :Real = 0.70710678118654752440084436210485;
OTE5 :Real = 1.0E3;
OTE13 :Real = 1.0E-7;
label
_1,_2,_3,_4,_5,_6;
begin
SPI := SYS010;   //  EQUIVALENCE
if ( X >= (-AL) ) 
 then goto _1;
RM := 0.0;
goto _6;
_1:
if ( X >= AL ) 
 then goto _2;
RM := SPI*Exp(-X*X*0.5);
RM := RM/SF35R(SYS029*X);
goto _6;
_2:
if ( X <= OTE5 ) 
 then goto _3;
SLAG := (1.0/X)/X;
RM := X/(1.0-SLAG);
goto _6;
_3:
SUM := 1.0/X;
SLAG := 1.0/X;
K := 1;
while ( K<=80 ) do
 begin
  SLAG := -SLAG*(K)/(X*X);
  SUM := SUM+SLAG;
  if ( Abs(SLAG) <= OTE13/X ) 
   then goto _5;
_4:
  inc(K,2);
 end;
_5:
RM := 1.0/SUM;
_6:
end;

end.
